AppTitle "BBBlitzer's CSI test"  
Graphics3D 800,600,16,2  
Const Ping%=200 ;   -    
Const FPS% = 50 

cam=CreateCamera()
PositionEntity cam,-10,0,-20

Global old=CreateSphere()
EntityColor old,255,255,0

Global News=CreateSphere()
EntityColor News,0,55,255
RotateEntity news,90,0,0
;EntityAlpha news,0

lig=CreateLight()
RotateEntity lig,90,0,0
AmbientLight 150,150,150


 
 
Type PACKET 
Field time% 
Field x#,y#,z# 
Field vx#,vy#,vz# 
Field ax#,ay#,az# 
End Type 
 
Global OldP.Packet= New Packet,NewP.Packet =New Packet 
Global  A#,B#,C#,D#,E#,F#,G#,H# 
Global DeltaPacket#,StepPerFrame#,tFPS#,spline_t# 
 
SeedRnd  MilliSecs () 
tFPS#=1000/FPS 
 tmUpdate = MilliSecs() + Ping% 
 tmFPS =  MilliSecs() + tFPS 
 GetPacket()    ;    
 SavePacket() ;    
 Delay Ping 
;==============Main Loop ============== 
While Not KeyHit(1)

TurnEntity news,.0,.6,0          ; ""
MoveEntity news,0,0,.1
  
DrawScr()       ;    
Delay tFps       ;   



;--------------------------------------------------------------------
;         ping  

If MilliSecs() >=  tmUpdate   Then     
             tmUpdate = MilliSecs()+Ping% 
            GetPacket() 
            ProcessPacket()  ;   
            SavePacket() 
            EndIf

;------------------------------------
RenderWorld 
Flip 
Wend 
End  
  
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=;  
;=Cubic Spline Interpolation=(OldPos,OldVel,NewPos, NewVel, NewAccel);  
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=;  
Function CalcSpline(Xold,Yold,Zold,  Xvelold,Yvelold,Zvelold  ,XNew,YNew,ZNew,  XvelNew,Yvelnew,Zvelnew,  XAccelNew,YAccelNew,ZAcccelNew,  Time) 
  
Local x,y,z,x0,y0,z0,x1,y1,z1,x2,y2,z2,x3,y3,z3  
 X0=Xold : Y0=Yold : Z0=Zold  
X1 = X0 + XVelOld  
Y1 = Y0 + YVelOld  
Z1 = Z0 + ZVelOld  
X2=XNew + XVelNew * Time + .5 * XAccelNew * Time^2  
Y2=YNew + YVelNew * Time + .5 * YAccelNew * Time^2  
Z2=ZNew + ZVelNew * Time + .5 * ZAccelNew * Time^2  
X3=XNew  
Y3=YNew  
Z3=Znew  
;Calc Cubic Spline Points  
RecursiveMathA=3*x2  
RecursiveMathB=3*x1  
RecursiveMathC=6*x1  
RecursiveMathD=3*x0 
 
RecursiveMathE=3*y2  
RecursiveMathF=3*y1  
RecursiveMathG=6*y1  
RecursiveMathH=3*y0
  
RecursiveMathI=3*z2  
RecursiveMathJ=3*z1  
RecursiveMathK=6*z1  
ResurciveMathL=3*z0  
 A = X3 - RecursiveMathA + RecursiveMathB - x0  
B = RecursiveMathA - RecursiveMathC + RecursiveMathD  
C = RecursiveMathB - RecursiveMathD  
D = x0 
 
E = y3 - RecursiveMathE + RecursiveMathF - y0  
F = RecursiveMathE - RecursiveMathG + RecursiveMathH  
G = RecursiveMathF - RecursiveMathH  
H = y0  

i = z3 - RecursiveMathi + RecursiveMathj - z0  
j = RecursiveMathi - RecursiveMathk + RecursiveMathl  
k = RecursiveMathj - RecursiveMathl  
l = z0  
End Function 
 
Function ProcessPacket()
 
DeltaPacket# =  (NewP\time - OldP\time)  ;    

CalcSpline(OldP\x,OldP\y,OldP\z,OldP\vx,OldP\vy,OldP\vz,NewP\x,NewP\y,NewP\z,NewP\vx,NewP\vy,NewP\vz,0,0,0,DeltaPacket/1000) 
StepPerFrame#= tFPS#/DeltaPacket#     ;       
spline_t# = 0              ;    
End Function 
;================================================= 
Function GetPacket() 
;      8)
 NewP\time% = MilliSecs()

 NewP\vx =(NewP\x-EntityX(news))/(NewP\time - OldP\time)
 NewP\vy = (NewP\y-EntityY(news))/(NewP\time - OldP\time)
  NewP\vz = (newp\z-EntityZ(news))/(NewP\time - OldP\time)
 
 NewP\x =EntityX(news) 
 NewP\y = EntityY(news) 
 newp\z=EntityZ(news)
 


 ;Color Rnd(255),Rnd(255),Rnd(255) 
 ;Rect NewP\x, NewP\y ,8,8,1 
 End Function 
;=================================================  
 Function  drawScr() 
  Color 255,255,255 
  x# = A*spline_t#^3 + B*spline_t#^2 + C*spline_t# + D  
  y#= E*spline_t#^3 + F*spline_t#^2 + G*spline_t# + H
  z# = i*spline_t#^3 + j*spline_t#^2 + k*spline_t# + l   
  PositionEntity old,x,y,z 
  If spline_t# <1 spline_t# = spline_t# + StepPerFrame# ;     () 
 End Function 
;================================================== 
 Function SavePacket() 
OldP\x = NewP\x 
OldP\y = NewP\y 
OldP\z = NewP\z 
OldP\vx = NewP\vx 
OldP\vy = NewP\vy 
OldP\vz = NewP\vz 
OldP\time = NewP\time 
End Function 